<?php

namespace Repository;

use Util\Instance\GeneralInstance;
use Teknisa\Model\Traits\TQuery;

class NoticesForOperator
{
    use TQuery;

    public function getCliente($cliente, $user)
    {
        $query =
            <<<SQL
                SELECT CDOPERADOR FROM OPERADOR
                WHERE CDCLIENTE = :CDCLIENTE
                AND (UPPER(NMACESSO) = UPPER(:OPERADOR)
                OR DSEMAILOPER = :OPERADOR)

SQL;
        $params = array(
            'CDCLIENTE' => $cliente,
            'OPERADOR'  => $user,
        );
        $result = GeneralInstance::getEntityManager()->getConnection()->fetchAll($query, $params);
        return $result;
    }

    public function getNotices($filtro)
    {
        $query =
            <<<SQL
                SELECT INF.DSTITULOINF, INF.TXCONTEUDOINF, INF.IDNOTIFICACAO, INF.DTEXPIRAINFO, INF.DTINFORMARIVI, INF.IDATIVO,
                INF.NRINFECOMMERCE, INF.CDPUBLICOALVO, INF.LINKDIRIMAGE,
                (
                    SELECT 
                        RTRIM(XMLAGG(XMLELEMENT(E, PROD.NRPRODUTO || ',')).EXTRACT('//text()'), ',') AS NRPRODUTO
                    FROM 
                        INFORMATIVO_PRODUTO PROD
                    WHERE 
                        PROD.NRINFECOMMERCE = INF.NRINFECOMMERCE
                ) AS NRPRODUTO
                FROM INFORMATIVOECOMMERCE INF
                WHERE TRUNC(SYSDATE) BETWEEN TRUNC(INF.DTINFORMARIVI) AND TRUNC(INF.DTEXPIRAINFO)
               $filtro

SQL;
        $result = GeneralInstance::getEntityManager()->getConnection()->fetchAll($query);
        return $result;
    }

    public function getTimeOutNotices()
    {
        $query =
            <<<SQL
                SELECT ID, DSNOME, QTDIAS, CDPUBLICOALVO, IDATIVO
                FROM INFORMATIVOECOMSILE
                WHERE CDPUBLICOALVO = 'OM'
                AND IDATIVO = 'S'

SQL;
        $result = GeneralInstance::getEntityManager()->getConnection()->fetchAll($query);
        return $result;
    }

    public function getInforEcomOper($user)
    {
        $query =
            <<<SQL
                SELECT DTINFOSILE 
                  FROM INFORMATIVOECOMSILEOPER
                 WHERE CDPUBLICOALVO = 'OM'
                   AND IDATIVO = 'S'
                   AND CDOPERADOR IN (SELECT CDOPERADOR
                                        FROM OPERADOR
                                       WHERE (UPPER(NMACESSO) = UPPER(:OPERADOR) OR DSEMAILOPER = :OPERADOR))

SQL;
        $params = array(
            'OPERADOR' => $user
        );

        $result = GeneralInstance::getEntityManager()->getConnection()->fetchAll($query, $params);
        return $result;
    }
}
